#lang racket/base

(require "api.rkt")

(provide (all-defined-out))

(define test-soa-rr
  (rr (domain '(#"example")) 'soa 'in 30
      (soa (domain '(#"ns" #"example"))
	   (domain '(#"tonyg" #"example"))
	   1
	   24
	   24
	   30
	   10)))

(define test-rrs
  (list (rr (domain '(#"localhost" #"example")) 'a 'in 30 '#(127 0 0 1))
	(rr (domain '(#"example")) 'mx 'in 30 (mx 5 (domain '(#"localhost" #"example"))))
	(rr (domain '(#"example")) 'mx 'in 30 (mx 10 (domain '(#"subns" #"example"))))
	(rr (domain '(#"google" #"example")) 'cname 'in 30 (domain '(#"www" #"google" #"com")))
	(rr (domain '(#"roar" #"example")) 'a 'in 30 '#(192 168 1 1))
	(rr (domain '(#"alias" #"example")) 'cname 'in 30 (domain '(#"roar" #"example")))
	(rr (domain '(#"ns" #"example")) 'a 'in 30 '#(127 0 0 1))
	(rr (domain '(#"hello" #"example")) 'txt 'in 30 '(#"Hello CRASH"))
	(rr (domain '(#"subzone" #"example")) 'ns 'in 30 (domain '(#"subns" #"example")))
	(rr (domain '(#"subns" #"example")) 'a 'in 30 '#(127 0 0 2))))

(define test-roots
  (list (rr (domain '()) 'ns 'in 30 (domain '(#"f" #"root-servers" #"net")))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(198 41 0 4))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 228 79 201))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 33 4 12))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 203 230 10))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 112 36 4))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(128 63 2 53))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 58 128 30))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(193 0 14 129))))

(define pathological-roots
  (list (rr (domain '(#"a")) 'ns 'in 30 (domain '(#"ns" #"b")))
	(rr (domain '(#"b")) 'ns 'in 30 (domain '(#"ns" #"a")))))

(define (test-port-number)
  (string->number
   (or (getenv "DNSPORT")
       (error 'test-port-number "Please set your DNSPORT environment variable."))))
